use async_graphql::{Context, FieldResult, Object};
use sqlx::postgres::PgPool;

use crate::models::modell::Modell;

#[derive(Default)]
pub struct ModellQuery {
    pub id: i32,
}

#[Object(extends)]
impl ModellQuery {
    // #[graphql(external)]
    // async fn id(&self) -> &i32 {
    //     &self.id
    // }

    async fn modelle<'a>(&self, ctx: &'a Context<'_>) -> FieldResult<Vec<Modell>> {
        let pool = ctx.data::<PgPool>()?;
        let rows = Modell::read_all(pool).await?;
        Ok(rows)
    }

    async fn modell<'a>(&self, ctx: &'a Context<'_>, id: i32) -> FieldResult<Modell> {
        let pool = ctx.data::<PgPool>()?;
        let row = Modell::read_one(pool, &id).await?;
        Ok(row)
    }

    // #[graphql(entity)]
    // async fn find_modell_by_id(&self, id: i32) -> Modell {
    //     Modell { id }
    // }
}
